import { entity } from '@google-cloud/datastore/build/src/entity';
import Entity from './entity';
export declare type EntityKey = entity.Key;
export declare type EntityData<T = {
    [key: string]: any;
}> = {
    [P in keyof T]: T[P];
};
export declare type FuncReturningPromise = (...args: any[]) => Promise<any>;
export declare type FunctionType = (...args: any[]) => any;
export declare type CustomEntityFunction<T extends object> = (this: Entity<T>, ...args: any[]) => any;
export declare type GenericObject = {
    [key: string]: any;
};
export declare type IdType = string | number;
export declare type Ancestor = (IdType)[];
export declare type EntityFormatType = 'ENTITY';
export declare type JSONFormatType = 'JSON';
export declare type DatastoreSaveMethod = 'upsert' | 'insert' | 'update';
export declare type PopulateRef = {
    path: string;
    select: string[];
};
export declare type PopulateMetaForEntity = {
    entity: Entity | EntityData;
    keysToFetch: EntityKey[];
    mapKeyToPropAndSelect: {
        [key: string]: {
            ref: PopulateRef;
        };
    };
};
export declare type PopulateFunction<T extends object> = (entitiesToProcess: null | Entity<T> | Array<Entity<T> | EntityData<T> | null>) => Promise<Entity<T> | EntityData<T> | null | Array<Entity<T> | EntityData<T> | null>>;
export interface PromiseWithPopulate<T> extends Promise<T> {
    populate: <U extends string | string[]>(refs?: U, properties?: U extends Array<string> ? never : string | string[]) => PromiseWithPopulate<T>;
}
/**
 * ---------------------------------------------------
 * Google Datastore Types
 * ---------------------------------------------------
 */
export declare type DatastoreOperator = '=' | '<' | '>' | '<=' | '>=' | 'HAS_ANCESTOR';
export interface OrderOptions {
    descending?: boolean;
}
